from collections.abc import Mapping, MutableSequence
from typing import Any, NoReturn, TypeVar

import google.protobuf.message
import proto
from google.protobuf.field_mask_pb2 import FieldMask
from google.rpc.status_pb2 import Status
from typing_extensions import Literal

from google.ads.googleads.v15.enums.types.response_content_type import (
    ResponseContentTypeEnum,
)
from google.ads.googleads.v15.resources.types.conversion_custom_variable import (
    ConversionCustomVariable,
)

_M = TypeVar("_M")

class ConversionCustomVariableOperation(proto.Message):
    update_mask: FieldMask
    create: ConversionCustomVariable
    update: ConversionCustomVariable
    def __init__(
        self: _M,
        mapping: _M | Mapping | google.protobuf.message.Message | None = None,
        *,
        ignore_unknown_fields: bool = False,
        update_mask: FieldMask = ...,
        create: ConversionCustomVariable = ...,
        update: ConversionCustomVariable = ...
    ) -> None: ...
    def __contains__(self, key: Literal["update_mask", "create", "update"]) -> bool: ...  # type: ignore[override]

class MutateConversionCustomVariableResult(proto.Message):
    resource_name: str
    conversion_custom_variable: ConversionCustomVariable
    def __init__(
        self: _M,
        mapping: _M | Mapping | google.protobuf.message.Message | None = None,
        *,
        ignore_unknown_fields: bool = False,
        resource_name: str = ...,
        conversion_custom_variable: ConversionCustomVariable = ...
    ) -> None: ...
    def __contains__(self, key: Literal["resource_name", "conversion_custom_variable"]) -> bool: ...  # type: ignore[override]

class MutateConversionCustomVariablesRequest(proto.Message):
    customer_id: str
    operations: MutableSequence[ConversionCustomVariableOperation]
    partial_failure: bool
    validate_only: bool
    response_content_type: ResponseContentTypeEnum.ResponseContentType
    def __init__(
        self: _M,
        mapping: _M | Mapping | google.protobuf.message.Message | None = None,
        *,
        ignore_unknown_fields: bool = False,
        customer_id: str = ...,
        operations: MutableSequence[ConversionCustomVariableOperation] = ...,
        partial_failure: bool = ...,
        validate_only: bool = ...,
        response_content_type: ResponseContentTypeEnum.ResponseContentType = ...
    ) -> None: ...
    def __contains__(self, key: Literal["customer_id", "operations", "partial_failure", "validate_only", "response_content_type"]) -> bool: ...  # type: ignore[override]

class MutateConversionCustomVariablesResponse(proto.Message):
    partial_failure_error: Status
    results: MutableSequence[MutateConversionCustomVariableResult]
    def __init__(
        self: _M,
        mapping: _M | Mapping | google.protobuf.message.Message | None = None,
        *,
        ignore_unknown_fields: bool = False,
        partial_failure_error: Status = ...,
        results: MutableSequence[MutateConversionCustomVariableResult] = ...
    ) -> None: ...
    def __contains__(self, key: Literal["partial_failure_error", "results"]) -> bool: ...  # type: ignore[override]
